local addonName, BGRep = ...
local AceAddon = LibStub("AceAddon-3.0")
BGRep = LibStub("AceAddon-3.0"):NewAddon(BGRep, addonName, "AceEvent-3.0")

local warsongFlags = 0
local arathiTicks = 0
local warsongID = 0
local arathiID = 0
local maxValue = 42000

function BGRep:FlagUpdate()
	local name, description, standingID, barMin, barMax, barValue = GetFactionInfoByID(warsongID)
	warsongFlags = math.floor((maxValue - barValue) / 100 + 0.5)
	
	name, description, standingID, barMin, barMax, barValue = GetFactionInfoByID(arathiID)
	arathiTicks = math.floor((maxValue - barValue) / 50 + 0.5)
	
	BGRep.frame.Warsong:SetText("Warsong Gulch: " .. warsongFlags)
	BGRep.frame.Arathi:SetText("Arathi Basin: " .. arathiTicks)
end

function BGRep:FactionCheck()
	englishFaction, localizedFaction = UnitFactionGroup(UnitName("player"))
	if englishFaction == "Horde" then
		warsongID = 889
		arathiID = 510
	elseif englishFaction == "Alliance" then
		warsongID = 890
		arathiID = 509
	end
end

function BGRep:OnDragStart(arg1)
	if arg1 == "LeftButton" then
		self:StartMoving()
	end
end

function BGRep:OnDragStop()
	self:StopMovingOrSizing()
end

function BGRep:SetupFrame()
	frame = CreateFrame("Frame", "MainFrame", UIParent)
	frame:SetMovable(true)
	frame:EnableMouse(true)
	frame:RegisterForDrag("LeftButton")
	frame:SetScript("OnMouseDown", BGRep.OnDragStart)
	frame:SetScript("OnMouseUp", BGRep.OnDragStop)
	
	--The code below makes the frame visible, and is not necessary to enable dragging.
	frame:SetPoint("CENTER"); frame:SetWidth(128); frame:SetHeight(45);
	local tex = frame:CreateTexture("ARTWORK");
	tex:SetAllPoints();
	tex:SetTexture(1.0, 0.5, 0); tex:SetAlpha(0.5);
	
	--Warsong Gulch Text
	frame.Warsong = frame:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	frame.Warsong:SetPoint("TOP", frame, "TOP", 0, -5)
	frame.Warsong:SetTextColor(1.0, 1.0, 1.0)
	frame.Warsong:SetText("Warsong Gulch: " .. warsongFlags)
	
	--Arathi Basin Text
	frame.Arathi = frame:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	frame.Arathi:SetPoint("TOP", frame, "TOP", 0, -25)
	frame.Arathi:SetTextColor(1.0, 1.0, 1.0)
	frame.Arathi:SetText("Arathi Basin: " .. arathiTicks)
end

function BGRep:FlagUpdate()
	local name, description, standingID, barMin, barMax, barValue = GetFactionInfoByID(warsongID)
	warsongFlags = math.floor((maxValue - barValue) / 100 + 0.5)
	
	name, description, standingID, barMin, barMax, barValue = GetFactionInfoByID(arathiID)
	arathiTicks = math.floor((maxValue - barValue) / 50 + 0.5)
	
	frame.Warsong:SetText("Warsong Gulch: " .. warsongFlags)
	frame.Arathi:SetText("Arathi Basin: " .. arathiTicks)
end

function BGRep:Initialize()
	if not Initialized then
		BGRep.FactionCheck()
		BGRep.SetupFrame()
		BGRep.FlagUpdate()
		Initialized = true
	end
end

function BGRep:OnInitialize()
	BGRep:RegisterEvent("CHAT_MSG_CHANNEL_NOTICE", BGRep.Initialize)
	BGRep:RegisterEvent("CHAT_MSG_COMBAT_FACTION_CHANGE", BGRep.FlagUpdate)
end